!     Last change:  LP   15 Mar 2005    1:51 pm
!****
!****   SUBROUTINES used in Beevers-Lipson Algorithm in alphabetical order
!****   Main Subroutines are BevLip and BevLipInit
!****   
!****   Made on 29.10.98
!****   Finished on 30.11.98
!****   Verified on 09.02.98
!****   Altered with 'Modulation' on 12.02.99
!
!     Interface to the FFTW subroutine
!******************************************************************
SUBROUTINE FFT(iFDirec)
  !******************************************************************
  !
  !      USE GlobalDefinitions
  USE GlobalVariables
  USE BevLipVariables
  !
  IMPLICIT NONE
  !
  !  Dummy argument, FFT backward or forward direction
  INTEGER :: iFDirec
  EXTERNAL :: dfftw_execute
  !
  SELECT CASE (iFDirec)
  CASE (1)
     call dfftw_execute(plan1) !Plan1 contains instructions for the direct transform
     CONTINUE
  CASE (-1)
     call dfftw_execute(plan2) !Plan2 contains instructions for the inverse transform
     SF=SF/Norm
  END SELECT
  !
END SUBROUTINE FFT
!
!       Initalisation
!******************************************************************
SUBROUTINE FFTInit
  !******************************************************************
  !  USE GlobalDefinitions
  USE GlobalVariables
  USE BevLipVariables
  !
  IMPLICIT NONE
  !
  INTEGER FFTW_FORWARD  
  PARAMETER(FFTW_FORWARD=+1)
  INTEGER FFTW_BACKWARD
  PARAMETER (FFTW_BACKWARD=-1)
  INTEGER FFTW_MEASURE
  PARAMETER (FFTW_MEASURE=0)
  INTEGER FFTW_PATIENT
  PARAMETER (FFTW_PATIENT=32)
  INTEGER FFTW_ESTIMATE
  PARAMETER (FFTW_ESTIMATE=64)
  !
  EXTERNAL dfftw_plan_dft
  !
  Norm=1.0D0
  DO DimCount=1, SDim
     !  Normalization
     Norm=Norm*NVoxR(DimCount)
  END DO
  !
  call dfftw_plan_dft(plan1,SDim,NVox,SF,SF,FFTW_FORWARD,FFTW_MEASURE)
  call dfftw_plan_dft(plan2,SDim,NVox,SF,SF,FFTW_BACKWARD,FFTW_MEASURE)      
  !
END SUBROUTINE FFTInit
